﻿#target illustrator
#targetengine "session"   

/////////////--------------------------- Main ---------------------------------------------
var WindowBorderInX = 5; var WindowBorderInY = 5;
var WindowMainWidth = 543; var WindowMainHeight = 35;
var ButtonWidth = 25; ButtonHeight = 25;
var SpaceBetweenX = 10;var SpaceBetweenY = 10;
var dlg = new Window('palette', 'FLIP                       © 2012 Alex Sheingart ',{x:100,y:100,width:WindowMainWidth,height:WindowMainHeight},{resizeable:true,closeButton:true,maximizeButton:true,minimizeButton:true});
dlgBackGroundColor = dlg.graphics.newBrush (dlg.graphics.BrushType.SOLID_COLOR, [0.7, 0.7, 0.7,0.8]);
dlg.graphics.backgroundColor  = dlgBackGroundColor;
dlg.pointX = WindowBorderInX; dlg.pointY =  WindowBorderInY;
var X_Flip,Y_Flip = null;


 function   ClickOnGroupDefPoint()
 {function NumToString(arg)
      { 
        if ((arg.toString()).indexOf('.',0) > -1)
            return (arg.toString()).substring(0,(arg.toString()).indexOf('.',0)) + ((arg.toString()).substring((arg.toString()).indexOf('.',0),(arg.toString()).indexOf('.',0)+4))
            else return arg.toString() 
            }
         for (i=0;i<this.parent.children.length;i++){if (this.selectPoint == true) this.parent.children[i].selectPoint = false; this.parent.children[i].graphics.backgroundColor = this.parent.children[i].graphics.newBrush (this.parent.children[i].graphics.BrushType.SOLID_COLOR, [1,1,1,1]);}
         this.graphics.backgroundColor = this.graphics.newBrush (this.graphics.BrushType.SOLID_COLOR, [0,0,0,1]);
         this.selectPoint = true;
         TempGroup = this;
         var ArrayGeometric = [null,null,null,null];
         
         if (app.documents.length != 0) 
         {
                               var bt = new BridgeTalk();
                               bt.target = "Illustrator";
                               bt.body = "{\n"+ CalculationGeometric.toString() + "\n"+
                               "var ArrayGeometric = CalculationGeometric();"+"\n"+
                               "ArrayGeometric.toSource();"+"\n"+
                               "}\n";
                               
                                bt.onResult = function( resultMsg ) 
                                {
                                    ArrayGeometric = eval(resultMsg.body);
                                    switch (TempGroup.NameOfPoint)
                                     { 
                                        case 'TL':{X_Flip = ArrayGeometric[0];Y_Flip = ArrayGeometric[1]; break;}
                                        case 'CL':{X_Flip = ArrayGeometric[0];Y_Flip = ArrayGeometric[1]+ ArrayGeometric[3]/2; break;}
                                        case 'BL':{X_Flip = ArrayGeometric[0];Y_Flip = ArrayGeometric[1]+ ArrayGeometric[3]; break;}
                                        case 'TC':{X_Flip = ArrayGeometric[0]+ArrayGeometric[2]/2;Y_Flip = ArrayGeometric[1]; break;}
                                        case 'CC':{X_Flip = ArrayGeometric[0]+ArrayGeometric[2]/2;Y_Flip = ArrayGeometric[1]+ ArrayGeometric[3]/2;break;}
                                        case 'BC':{X_Flip = ArrayGeometric[0]+ArrayGeometric[2]/2;Y_Flip = ArrayGeometric[1]+ ArrayGeometric[3]; break;}
                                        case 'TR':{X_Flip = ArrayGeometric[0]+ArrayGeometric[2];Y_Flip = ArrayGeometric[1];break;}
                                        case 'CR':{X_Flip = ArrayGeometric[0]+ArrayGeometric[2];Y_Flip = ArrayGeometric[1]+ ArrayGeometric[3]/2;break;}
                                        case 'BR':{X_Flip = ArrayGeometric[0]+ArrayGeometric[2];Y_Flip = ArrayGeometric[1]+ ArrayGeometric[3]; break;}
                                        default:;
                                       }
                                   X_DefPoint.text = 'X: '+NumToString(X_Flip); Y_DefPoint.text = 'Y: '+NumToString(Y_Flip);
                                 }
                                 bt.onError = function( errorMsg )
                                 {
                                      alert("Error = " + errorMsg.body); 
                                 }
                                bt.send();      
            } 
 
  }

function  CalculationGeometric()
{
         var X_TopLeft, X_BotRight = null;
         var Y_TopLeft, Y_BotRight = null;
         var Obj_Width = null;
         var Obj_Height = null;
          if (app.documents.length  != 0)
          {
              if (app.activeDocument.selection.length > 0){
                  if (!app.activeDocument.selection[0].guides) {
                          var objectselect = app.activeDocument.selection[0];
                          X_TopLeft = (app.activeDocument.selection[0].visibleBounds[0]);
                          Y_TopLeft = (app.activeDocument.selection[0].visibleBounds[1]);
                          X_BotRight = (app.activeDocument.selection[0].visibleBounds[2]);
                          Y_BotRight = (app.activeDocument.selection[0].visibleBounds[3]);                  
                  }
                  for (var i=1;i<app.activeDocument.selection.length;i++) 
                  if (!app.activeDocument.selection[i].guides) {
                         if (X_TopLeft > (app.activeDocument.selection[i].visibleBounds[0])) 
                                    {X_TopLeft = (app.activeDocument.selection[i].visibleBounds[0])};
                        if (Y_TopLeft < (app.activeDocument.selection[i].visibleBounds[1])) 
                                        {Y_TopLeft =(app.activeDocument.selection[i].visibleBounds[1])};
                        if (X_BotRight < (app.activeDocument.selection[i].visibleBounds[2])) 
                                        {X_BotRight = (app.activeDocument.selection[i].visibleBounds[2])};
                        if (Y_BotRight > (app.activeDocument.selection[i].visibleBounds[3])) 
                                                            {Y_BotRight = (app.activeDocument.selection[i].visibleBounds[3])};
                      }
                  }
              for (var i=1;i<app.activeDocument.selection.length;i++){app.activeDocument.selection[i].selected = false}
              Obj_Width =  Math.abs(X_BotRight - X_TopLeft);
              Obj_Height = Math.abs(Y_BotRight - Y_TopLeft);
       return[X_TopLeft,(-1)*Y_TopLeft,Obj_Width,Obj_Height];
    }
}

/*---------------------------------------------  End Panel of Deference Point  -------------------------------------------*/    
/*           function  onDraw Button                     */
function customDrawButton()
{ with(this)
    {
        graphics.drawOSControl();
        switch (helpTip)
        {
            case  'Flip Vertlical':{
               graphics.strokePath (LineColorContur, LineConturBlack);
               graphics.strokePath (LineColorContur, DashedLine);
               graphics.rectPath (bounds.width/2+4, 4,bounds.width/2-8, bounds.height-8);
               fillBrush = BrushColorRect;
               graphics.fillPath(fillBrush);
               break;
               }
           case 'Flip Vertical with Duplicate':{
               graphics.strokePath (LineColorContur, DashedLine);
               graphics.rectPath (bounds.width/2+3, 4,bounds.width/2-8, bounds.height-8);
               fillBrush = BrushColorRect;
               graphics.fillPath(fillBrush);
               graphics.rectPath (4, 4,bounds.width/2-7, bounds.height-8);
               fillBrush = BrushColorRect;
               graphics.fillPath(fillBrush);               
               break;
               }
           case  'Flip Horizontal':{
               graphics.strokePath (LineColorContur, LineConturBlack);
               graphics.strokePath (LineColorContur, DashedLine);
               graphics.rectPath (4,bounds.height/2+4,bounds.width-8, bounds.height/2-8);
               fillBrush = BrushColorRect;
               graphics.fillPath(fillBrush);
               break;
               }
           case 'Flip Horizontal with Duplicate':{
               graphics.strokePath (LineColorContur, DashedLine);
               graphics.rectPath (4,4,bounds.width-8, bounds.height/2-7);
               fillBrush = BrushColorRect;
               graphics.fillPath(fillBrush);
               graphics.rectPath (4,bounds.height/2+4,bounds.width-8, bounds.height/2-8);
               fillBrush = BrushColorRect;
               graphics.fillPath(fillBrush);
               break;
               }
           case 'Flip Diagonal':{
               graphics.strokePath (LineColorContur, LineConturBlack);
               graphics.strokePath (LineColorContur, DashedLineGor);
               graphics.strokePath (LineColorContur, DashedLineVert);
               graphics.rectPath (bounds.width/2+4,bounds.height/2+4,bounds.width/2-8, bounds.height/2-8);
               fillBrush = BrushColorRect;
               graphics.fillPath(fillBrush);
               break;
               }
           case 'Flip Diagonal with Duplicate':{
               graphics.strokePath (LineColorContur, DashedLineGor);
               graphics.strokePath (LineColorContur, DashedLineVert);
               graphics.rectPath (3,3,bounds.width/2-7, bounds.height/2-7);
               fillBrush = BrushColorRect;
               graphics.fillPath(fillBrush);
               graphics.rectPath (bounds.width/2+4,bounds.height/2+4,bounds.width/2-8, bounds.height/2-8);
               fillBrush = BrushColorRect;
               graphics.fillPath(fillBrush);
               break;
               }           
           default:;
        }
    graphics.rectPath(0,0,bounds.width-1,bounds.height-1);
    graphics.fillPath(graphics.newBrush(graphics.BrushType.SOLID_COLOR, [1, 1, 1, 0]));
    }
}
function btnMouseEventHandler(event) 
{   
    switch (event.type)
    {
    case 'mouseover':{this.graphics.backgroundColor = this.graphics.newBrush (this.graphics.BrushType.SOLID_COLOR, [0, 0, 0,0]);break}
    case 'mouseout':{this.graphics.backgroundColor = this.graphics.newBrush (this.graphics.BrushType.SOLID_COLOR, [0, 0, 0,0]);break}
    case 'mousedown':{this.graphics.backgroundColor = this.graphics.newBrush (this.graphics.BrushType.SOLID_COLOR, [0.3, 0.3, 0.3,0.5]); break}
    case 'mouseup':{this.graphics.backgroundColor = this.graphics.newBrush (this.graphics.BrushType.SOLID_COLOR, [0, 0, 0,0]);
                               if ((X_Flip != null)&(Y_Flip != null)) 
                               {
                               if (app.documents.length != 0) 
                                {
                                    var bt = new BridgeTalk();
                                    bt.target = "Illustrator";
                                    bt.body = "{\n" + "var X_Flip = " + X_Flip.toString()+";" +"\n"+
                                    "var Y_Flip = " + Y_Flip.toString()+";" +"\n"+
                                    "var typeFlip = '" + this.helpTip + "';" + "\n"+
                                    "FlipDirection(typeFlip,X_Flip,Y_Flip);"+"\n"+
                                    FlipDirection.toString() + "\n" +"}\n";
                                    bt.onResult = function( resultMsg ) 
                                    {
                                        //alert("Result = " + resultMsg.body);
                                    }
                                 bt.onError = function( errorMsg )
                                    {
                                      alert("Error = " + errorMsg.body); 
                                    }
                               bt.send();
                               break}
                           }
                       }
    default:;
        }
    }
function FlipDirection(typeFlip,X_Flip,Y_Flip) 
{
    if (app.activeDocument.selection.length > 0)
    {   var AmountSelected = app.activeDocument.selection.length
        if ((typeFlip.indexOf ('Duplicate', 0)) > 0) 
                                var ArrayOfObjects = new Array(AmountSelected);
         for (var i=0;i<AmountSelected;i++)
         { switch (typeFlip)
             {  
                 case 'Flip Vertlical':{ app.activeDocument.selection[i].resize (-100, 100);
                                                app.activeDocument.selection[i].translate (2*(X_Flip-app.activeDocument.selection[i].geometricBounds[2])+(app.activeDocument.selection[i].geometricBounds[2]-app.activeDocument.selection[i].geometricBounds[0]));
                                              break;}
                 case 'Flip Vertical with Duplicate':{ArrayOfObjects[i] = app.activeDocument.selection[i].duplicate();
                                                                    ArrayOfObjects[i].selected = false;
                                                                    ArrayOfObjects[i].resize (-100, 100);
                                                                    //ArrayOfObjects[i].translate (2*(X_Flip-ArrayOfObjects[i].visibleBounds[2])+(ArrayOfObjects[i].visibleBounds[2]-ArrayOfObjects[i].visibleBounds[0]));
                                                                    ArrayOfObjects[i].translate (2*(X_Flip-ArrayOfObjects[i].geometricBounds[2])+(ArrayOfObjects[i].geometricBounds[2]-ArrayOfObjects[i].geometricBounds[0]));
                                                                    break}
                 case 'Flip Horizontal':{ app.activeDocument.selection[i].resize (100, -100); 
                                                   app.activeDocument.selection[i].translate (0,2*((-1)*Y_Flip-app.activeDocument.selection[i].geometricBounds[3])+(app.activeDocument.selection[i].geometricBounds[3]-app.activeDocument.selection[i].geometricBounds[1]));
                                                 break;}
                 case 'Flip Horizontal with Duplicate':{ArrayOfObjects[i] = app.activeDocument.selection[i].duplicate();
                                                                       ArrayOfObjects[i].selected = false;
                                                                       ArrayOfObjects[i].resize (100, -100);
                                                                       ArrayOfObjects[i].translate (0,2*((-1)*Y_Flip-ArrayOfObjects[i].geometricBounds[3])+(ArrayOfObjects[i].geometricBounds[3]-ArrayOfObjects[i].geometricBounds[1]));
                                                                    break;}
                 case 'Flip Diagonal':{ app.activeDocument.selection[i].resize (-100, -100);
                                                  app.activeDocument.selection[i].translate (2*(X_Flip-app.activeDocument.selection[i].geometricBounds[2])+(app.activeDocument.selection[i].geometricBounds[2]-app.activeDocument.selection[i].geometricBounds[0])); 
                                                  app.activeDocument.selection[i].translate (0,2*((-1)*Y_Flip-app.activeDocument.selection[i].geometricBounds[3])+(app.activeDocument.selection[i].geometricBounds[3]-app.activeDocument.selection[i].geometricBounds[1]));
                                                 break;}   
                 case 'Flip Diagonal with Duplicate':{ArrayOfObjects[i] = app.activeDocument.selection[i].duplicate();
                                                                    ArrayOfObjects[i].selected = false;
                                                                    ArrayOfObjects[i].resize (-100, -100);
                                                                    ArrayOfObjects[i].translate (2*(X_Flip-ArrayOfObjects[i].geometricBounds[2])+(ArrayOfObjects[i].geometricBounds[2]-ArrayOfObjects[i].geometricBounds[0]));
                                                                    ArrayOfObjects[i].translate (0,2*((-1)*Y_Flip-ArrayOfObjects[i].geometricBounds[3])+(ArrayOfObjects[i].geometricBounds[3]-ArrayOfObjects[i].geometricBounds[1]));
                                                                    break;}                                                  
                 default:;
              }
             }
         }
        if ((typeFlip.indexOf ('Duplicate', 0)) > 0) { 
            i = 0;
            do{app.activeDocument.selection[i].selected = false} while(app.activeDocument.selection.length>0)
            for (i=0;i<ArrayOfObjects.length;i++){ArrayOfObjects[i].selected = true;}
            }
    }

//-----------------------------    create button Flip Horizontal     ----------------------------------------------------------------/
        var ButtonFlipVert = dlg.add('button',{x: dlg.pointX,y:dlg.pointY,width:ButtonWidth,height:ButtonHeight});
        ButtonFlipVert.enabled = false;
        var GroupFlipVert = dlg.add('group',{x: dlg.pointX,y:dlg.pointY,width:ButtonWidth,height:ButtonHeight});
        GroupFlipVert.helpTip = 'Flip Vertlical';
        GroupFlipVert.graphics.backgroundColor = GroupFlipVert.graphics.newBrush (GroupFlipVert.graphics.BrushType.SOLID_COLOR, [0.8, 0.8, 0.8,0]);
        GroupFlipVert.addEventListener ('mouseover', btnMouseEventHandler, false);
        GroupFlipVert.addEventListener ('mouseout', btnMouseEventHandler, false);
        GroupFlipVert.addEventListener ('mousedown', btnMouseEventHandler, false);
        GroupFlipVert.addEventListener ('mouseup', btnMouseEventHandler, false);
        ButtonFlipVert.LineColorContur = ButtonFlipVert.graphics.newPen(ButtonFlipVert.graphics.PenType.SOLID_COLOR, [0, 0, 0, 1],1 );
        ButtonFlipVert.helpTip = 'Flip Vertlical';
        with (ButtonFlipVert) {
            graphics.newPath();
            graphics.moveTo(4,4);
            graphics.lineTo(bounds.width/2-4,4);
            graphics.lineTo(bounds.width/2-4, bounds.height - 4);
            graphics.lineTo(4, bounds.height - 4);
            graphics.lineTo(4,4);    
            }
        ButtonFlipVert.LineConturBlack = ButtonFlipVert.graphics.currentPath;
        ButtonFlipVert.BrushColorRect = ButtonFlipVert.graphics.newBrush(ButtonFlipVert.graphics.BrushType.SOLID_COLOR, [1, 1, 1, 1]);
         with  (ButtonFlipVert) {
            graphics.newPath();
            for (i=0;i<bounds.height;i=i+5){
            graphics.moveTo(bounds.width/2,i+2);
            graphics.lineTo(bounds.width/2,i+5);}
            }
        ButtonFlipVert.DashedLine = ButtonFlipVert.graphics.currentPath;
        ButtonFlipVert.onDraw = customDrawButton;
        dlg.pointX = dlg.pointX + ButtonFlipVert.bounds.width + SpaceBetweenX;


//-----------------------------      end create button Flip Horizontal     ----------------------------------------------------------------/

//---------------------------------------------  create button Flip Horizontal with Duplicate    ----------------------------------------------------------------/
        var ButtonFlipVertDupl = dlg.add('button',{x: dlg.pointX,y:dlg.pointY,width:ButtonWidth,height:ButtonHeight});
        ButtonFlipVertDupl.enabled = false;
        var GroupFlipVertDupl = dlg.add('group',{x: dlg.pointX,y:dlg.pointY,width:ButtonWidth,height:ButtonHeight});
        GroupFlipVertDupl.helpTip = 'Flip Vertical with Duplicate';
        GroupFlipVertDupl.graphics.backgroundColor = GroupFlipVertDupl.graphics.newBrush (GroupFlipVertDupl.graphics.BrushType.SOLID_COLOR, [0.8, 0.8, 0.8,0]);
        GroupFlipVertDupl.addEventListener ('mouseover', btnMouseEventHandler, false);
        GroupFlipVertDupl.addEventListener('mouseout', btnMouseEventHandler, false);
        GroupFlipVertDupl.addEventListener('mousedown', btnMouseEventHandler, false);
        GroupFlipVertDupl.addEventListener('mouseup', btnMouseEventHandler, false);
        ButtonFlipVertDupl.LineColorContur = ButtonFlipVertDupl.graphics.newPen(ButtonFlipVertDupl.graphics.PenType.SOLID_COLOR, [0, 0, 0, 1],1 );
        ButtonFlipVertDupl.helpTip = 'Flip Vertical with Duplicate';
        ButtonFlipVertDupl.BrushColorRect = ButtonFlipVertDupl.graphics.newBrush(ButtonFlipVertDupl.graphics.BrushType.SOLID_COLOR, [1, 1, 1, 1]);
         with  (ButtonFlipVertDupl) {
            graphics.newPath();
            for (i=0;i<bounds.height;i=i+5){
            graphics.moveTo(bounds.width/2,i+2);
            graphics.lineTo(bounds.width/2,i+5);}
            }
        ButtonFlipVertDupl.DashedLine = ButtonFlipVertDupl.graphics.currentPath;
        ButtonFlipVertDupl.onDraw = customDrawButton;
        dlg.pointX = dlg.pointX + ButtonFlipVertDupl.bounds.width + SpaceBetweenX;
//---------------------------------------------    end create button Flip Horizontal  with Duplicate    ----------------------------------------------------------------/

//---------------------------------------------    create button Flip Vertical     ----------------------------------------------------------------/
       var ButtonFlipHoriz = dlg.add('button',{x: dlg.pointX,y:dlg.pointY,width:ButtonWidth,height:ButtonHeight});
       ButtonFlipHoriz.enabled = false;
        var GroupFlipHoriz = dlg.add('group',{x: dlg.pointX,y:dlg.pointY,width:ButtonWidth,height:ButtonHeight});
        GroupFlipHoriz.helpTip = 'Flip Horizontal';
        GroupFlipHoriz.graphics.backgroundColor = GroupFlipHoriz.graphics.newBrush (GroupFlipHoriz.graphics.BrushType.SOLID_COLOR, [0.8, 0.8, 0.8,0]);
        GroupFlipHoriz.addEventListener ('mouseover', btnMouseEventHandler, false);
        GroupFlipHoriz.addEventListener('mouseout', btnMouseEventHandler, false);
        GroupFlipHoriz.addEventListener('mousedown', btnMouseEventHandler, false);
        GroupFlipHoriz.addEventListener('mouseup', btnMouseEventHandler, false);
        ButtonFlipHoriz.LineColorContur = ButtonFlipHoriz.graphics.newPen(ButtonFlipHoriz.graphics.PenType.SOLID_COLOR, [0, 0, 0, 1],1 );
        ButtonFlipHoriz.helpTip = 'Flip Horizontal';
        with (ButtonFlipHoriz) {
            graphics.newPath();
            graphics.moveTo(4,4);
            graphics.lineTo(bounds.width-4,4);
            graphics.lineTo(bounds.width-4, bounds.height/2 - 4);
            graphics.lineTo(4, bounds.height/2 - 4);
            graphics.lineTo(4,4);    
            }
        ButtonFlipHoriz.LineConturBlack = ButtonFlipHoriz.graphics.currentPath;
        ButtonFlipHoriz.BrushColorRect = ButtonFlipHoriz.graphics.newBrush(ButtonFlipHoriz.graphics.BrushType.SOLID_COLOR, [1, 1, 1, 1]);
         with  (ButtonFlipHoriz) {
            graphics.newPath();
            for (i=0;i<bounds.width;i=i+5){
            graphics.moveTo(i+2,bounds.height/2);
            graphics.lineTo(i+5,bounds.height/2);}
            }
        ButtonFlipHoriz.DashedLine = ButtonFlipHoriz.graphics.currentPath;
        ButtonFlipHoriz.onDraw = customDrawButton;
        dlg.pointX = dlg.pointX + ButtonFlipHoriz.bounds.width + SpaceBetweenX;
//---------------------------------------------    end create button Flip Horizical     ----------------------------------------------------------------/

//---------------------------------------------     create button Flip Horizical with Duplicate    ----------------------------------------------------------------/
        var ButtonFlipHorizDupl = dlg.add('button',{x: dlg.pointX,y:dlg.pointY,width:ButtonWidth,height:ButtonHeight});
        ButtonFlipHorizDupl.enabled = false;
        var GroupFlipHorizDupl = dlg.add('group',{x: dlg.pointX,y:dlg.pointY,width:ButtonWidth,height:ButtonHeight});
        GroupFlipHorizDupl.helpTip = 'Flip Horizontal with Duplicate';
        GroupFlipHorizDupl.graphics.backgroundColor = GroupFlipHorizDupl.graphics.newBrush (GroupFlipHorizDupl.graphics.BrushType.SOLID_COLOR, [0.8, 0.8, 0.8,0]);
        GroupFlipHorizDupl.addEventListener ('mouseover', btnMouseEventHandler, false);
        GroupFlipHorizDupl.addEventListener('mouseout', btnMouseEventHandler, false);
        GroupFlipHorizDupl.addEventListener('mousedown', btnMouseEventHandler, false);
        GroupFlipHorizDupl.addEventListener('mouseup', btnMouseEventHandler, false);
        ButtonFlipHorizDupl.LineColorContur = ButtonFlipHorizDupl.graphics.newPen(ButtonFlipHorizDupl.graphics.PenType.SOLID_COLOR, [0, 0, 0, 1],1 );
        ButtonFlipHorizDupl.helpTip = 'Flip Horizontal with Duplicate';
        ButtonFlipHorizDupl.BrushColorRect = ButtonFlipHorizDupl.graphics.newBrush(ButtonFlipHorizDupl.graphics.BrushType.SOLID_COLOR, [1, 1, 1, 1]);
         with  (ButtonFlipHorizDupl) {
            graphics.newPath();
            for (i=0;i<bounds.width;i=i+5){
            graphics.moveTo(i+2,bounds.height/2);
            graphics.lineTo(i+5,bounds.height/2);}
            }
        ButtonFlipHorizDupl.DashedLine = ButtonFlipHorizDupl.graphics.currentPath;
        ButtonFlipHorizDupl.onDraw = customDrawButton;
        dlg.pointX = dlg.pointX + ButtonFlipHorizDupl.bounds.width + SpaceBetweenX;
//---------------------------------------------        end create button Flip Vertical  with Duplicate    ----------------------------------------------------------------/

//---------------------------------------------    create button Flip Diagonal     ----------------------------------------------------------------/
        var ButtonFlipDiag = dlg.add('button',{x: dlg.pointX,y:dlg.pointY,width:ButtonWidth,height:ButtonHeight});
        ButtonFlipDiag.enabled = false;
        var GroupFlipDiag = dlg.add('group',{x: dlg.pointX,y:dlg.pointY,width:ButtonWidth,height:ButtonHeight});
        GroupFlipDiag.helpTip = 'Flip Diagonal';
        GroupFlipDiag.graphics.backgroundColor = GroupFlipDiag.graphics.newBrush (GroupFlipDiag.graphics.BrushType.SOLID_COLOR, [0.8, 0.8, 0.8,0]);
        GroupFlipDiag.addEventListener ('mouseover', btnMouseEventHandler, false);
        GroupFlipDiag.addEventListener('mouseout', btnMouseEventHandler, false);
        GroupFlipDiag.addEventListener('mousedown', btnMouseEventHandler, false);
        GroupFlipDiag.addEventListener('mouseup', btnMouseEventHandler, false);
        ButtonFlipDiag.LineColorContur = ButtonFlipDiag.graphics.newPen(ButtonFlipDiag.graphics.PenType.SOLID_COLOR, [0, 0, 0, 1],1 );
        ButtonFlipDiag.helpTip = 'Flip Diagonal';
        with (ButtonFlipDiag) {
            graphics.newPath();
            graphics.moveTo(4,4);
            graphics.lineTo(bounds.width/2-4,4);
            graphics.lineTo(bounds.width/2-4, bounds.height/2 - 4);
            graphics.lineTo(4, bounds.height/2 - 4);
            graphics.lineTo(4,4);    
            }
        ButtonFlipDiag.LineConturBlack = ButtonFlipDiag.graphics.currentPath;
        ButtonFlipDiag.BrushColorRect = ButtonFlipDiag.graphics.newBrush(ButtonFlipDiag.graphics.BrushType.SOLID_COLOR, [1, 1, 1, 1]);
         with  (ButtonFlipDiag) {
            graphics.newPath();
            for (i=0;i<bounds.width;i=i+5){
            graphics.moveTo(i+2,bounds.height/2);
            graphics.lineTo(i+5,bounds.height/2);}
            }
        ButtonFlipDiag.DashedLineGor = ButtonFlipDiag.graphics.currentPath;
         with  (ButtonFlipDiag) {
            graphics.newPath();
            for (i=0;i<bounds.height;i=i+5){
            graphics.moveTo(bounds.width/2,i+2);
            graphics.lineTo(bounds.width/2,i+5);}
            }
        ButtonFlipDiag.DashedLineVert = ButtonFlipDiag.graphics.currentPath;
        ButtonFlipDiag.onDraw = customDrawButton;
        dlg.pointX = dlg.pointX + ButtonFlipDiag.bounds.width + SpaceBetweenX;
//---------------------------------------------    end create button Flip Diagonal     ----------------------------------------------------------------/

//---------------------------------------------    create button Flip Diagonal    with Duplicate  ----------------------------------------------------------------/
        var ButtonFlipDiagDupl = dlg.add('button',{x: dlg.pointX,y:dlg.pointY,width:ButtonWidth,height:ButtonHeight});
        ButtonFlipDiagDupl.enabled = false;
        var GroupFlipDiagDupl = dlg.add('group',{x: dlg.pointX,y:dlg.pointY,width:ButtonWidth,height:ButtonHeight});
        GroupFlipDiagDupl.helpTip = 'Flip Diagonal with Duplicate';
        GroupFlipDiagDupl.graphics.backgroundColor = GroupFlipDiagDupl.graphics.newBrush (GroupFlipDiagDupl.graphics.BrushType.SOLID_COLOR, [0.8, 0.8, 0.8,0]);
        GroupFlipDiagDupl.addEventListener ('mouseover', btnMouseEventHandler, false);
        GroupFlipDiagDupl.addEventListener('mouseout', btnMouseEventHandler, false);
        GroupFlipDiagDupl.addEventListener('mousedown', btnMouseEventHandler, false);
        GroupFlipDiagDupl.addEventListener('mouseup', btnMouseEventHandler, false);
        ButtonFlipDiagDupl.LineColorContur = ButtonFlipDiagDupl.graphics.newPen(ButtonFlipDiagDupl.graphics.PenType.SOLID_COLOR, [0, 0, 0, 1],1 );
        ButtonFlipDiagDupl.helpTip = 'Flip Diagonal with Duplicate';
        ButtonFlipDiagDupl.BrushColorRect = ButtonFlipDiagDupl.graphics.newBrush(ButtonFlipDiagDupl.graphics.BrushType.SOLID_COLOR, [1, 1, 1, 1]);
         with  (ButtonFlipDiagDupl) {
            graphics.newPath();
            for (i=0;i<bounds.width;i=i+5){
            graphics.moveTo(i+2,bounds.height/2);
            graphics.lineTo(i+5,bounds.height/2);}
            }
        ButtonFlipDiagDupl.DashedLineGor = ButtonFlipDiagDupl.graphics.currentPath;
         with  (ButtonFlipDiagDupl) {
            graphics.newPath();
            for (i=0;i<bounds.height;i=i+5){
            graphics.moveTo(bounds.width/2,i+2);
            graphics.lineTo(bounds.width/2,i+5);}
            }
        ButtonFlipDiagDupl.DashedLineVert = ButtonFlipDiagDupl.graphics.currentPath;
        ButtonFlipDiagDupl.onDraw = customDrawButton;
        dlg.pointX = dlg.pointX + ButtonFlipDiagDupl.bounds.width + SpaceBetweenX;
//---------------------------------------------    end create button Flip Diagonal  with Duplicate ----------------------------------------------------------------/

//---------------------------------------------  Panel of Deference Point  -------------------------------------------/    
    var PanelDefPoint = dlg.add('panel',{x:dlg.pointX,y:dlg.pointY-1,width:100,height:dlg.bounds.height-2*WindowBorderInY+3});
    PanelDefPoint.graphics.backgroundColor = dlgBackGroundColor;
    dlg.pointX = dlg.pointX + PanelDefPoint.bounds.width + SpaceBetweenX;
    var GroupDefPoint = PanelDefPoint.add('group',{x:1,y:1,width:PanelDefPoint.bounds.height-2,height:PanelDefPoint.bounds.height-2});
    var X_DefPoint = PanelDefPoint.add('StaticText',{x:GroupDefPoint.bounds.right+2,y:0,width:PanelDefPoint.bounds.width-GroupDefPoint.bounds.width-2,height:10});
    X_DefPoint.text = 'X:';
    var Y_DefPoint = PanelDefPoint.add('StaticText',{x:GroupDefPoint.bounds.right+2,y:11,width:PanelDefPoint.bounds.width-GroupDefPoint.bounds.width-2,height:10});
    Y_DefPoint.text = 'Y:';
    var NameOfPoint =[['TL','CL','BL'],['TC','CC','BC'],['TR','CR','BR']];
    for (i=0;i<24;i=i+8){ 
        for (j=0;j<24;j=j+8){ 
            GroupDefPoint.add('group',{x:i,y:j,width:5,height:5});
            GroupDefPoint.children[GroupDefPoint.children.length-1].graphics.backgroundColor =  GroupDefPoint.children[GroupDefPoint.children.length-1].graphics.newBrush (GroupDefPoint.children[GroupDefPoint.children.length-1].graphics.BrushType.SOLID_COLOR, [1,1,1,1]);
            GroupDefPoint.children[GroupDefPoint.children.length-1].NameOfPoint = NameOfPoint[i/8][j/8];
            GroupDefPoint.children[GroupDefPoint.children.length-1].selectPoint = false;
            GroupDefPoint.children[GroupDefPoint.children.length-1].addEventListener( 'click', ClickOnGroupDefPoint);
            }
        }
    dlg.bounds.width = dlg.pointX;
dlg.show();